import socket

LOCAL_IP = '127.0.0.1'
SERVER_PORT = 29987
SERVER_BUFFER = 1024

udp_server_socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
udp_server_socket.bind((LOCAL_IP, SERVER_PORT))

waiting_for_connection = True

while waiting_for_connection:
    received = udp_server_socket.recvfrom(SERVER_BUFFER)
    message = received[0]
    address = received[1]

    decoded_message = message.decode('UTF-8')
    if decoded_message.split(';')[0] != 'PYPONGREQ':
        message = 'PYPONGRST;ERROR:INVALID HEADER'
        udp_server_socket.sendto(message.encode('UTF-8'), address)
    else:
        message = 'PYPONGRST;ECHO:{0}'.format(decoded_message)
        udp_server_socket.sendto(message.encode('UTF-8'), address)

udp_server_socket.close()
